// --------------------------------------------------------
// Copyright (c)
//
// contributions by Ansgar
//                  ansgar.radermacher@cea.fr
// maintained by    CEA LIST
//                  info-list@cea.fr

// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#include "sendReceive/SendClient.h"

using namespace std::chrono_literals;
// declare options
rclcpp::NodeOptions sendclient_options;

int main(int argc, char **argv) {
  rclcpp::init(argc, argv);

  auto sendclient = std::make_shared < sendReceive::SendClient
      > (sendclient_options);

  RCLCPP_INFO(sendclient->get_logger(), "SendClient has been initialized");

  sendclient->register_on_activate(
      [&sendclient](const rclcpp_lifecycle::State&) {
        // periodic execution (1s) for Request using a wall timer
        // create a callback group for the timer
        sendclient->timer_Request_ = sendclient->create_wall_timer(1s,
            std::bind(&sendReceive::SendClient::fSendMap, sendclient),
            sendclient->cbg_t_Request_);
        return rclcpp_lifecycle::node_interfaces::LifecycleNodeInterface::CallbackReturn::SUCCESS;
      }
  );
  sendclient->register_on_deactivate(
      [&sendclient](const rclcpp_lifecycle::State&) {
        // stop timer of Request
        sendclient->timer_Request_->cancel();
        return rclcpp_lifecycle::node_interfaces::LifecycleNodeInterface::CallbackReturn::SUCCESS;
      }
  );
  sendclient->register_on_shutdown(
      [&sendclient](const rclcpp_lifecycle::State&) {
        // stop timer of Request
        sendclient->timer_Request_->cancel();
        return rclcpp_lifecycle::node_interfaces::LifecycleNodeInterface::CallbackReturn::SUCCESS;
      }
  );

  rclcpp::executors::MultiThreadedExecutor executor;

  executor.add_node(sendclient->get_node_base_interface());

  executor.spin();
  rclcpp::shutdown();
}

